
//
//   Substitudo por SendMail.prg porque nele se pode configurar o servidor de e-mails e
//               no solicita confirmao ao operador.
//
//   Este programa usa o servidor de e-mail padro da instalao e envia mensagem para o operador
//        informando que o e-mail est sendo enviado.
//

#include 'Dll.ch'
#include 'bap.ch'

        #define MAPI_ORIG   0
        #define MAPI_TO     1
        #define MAPI_CC     2
        #define MAPI_BCC    3
 ////////////
 //
FUNCTION ApiSendMail_(nParent, cSubject, cText, cSName, cSAdresse, cEName, cEAdresse, cTFile)
 //      Envia e-mails, ativando uma tela que avisa que o e-mail ser enviado, onde:
 //            [<nParent>] -> parent window onde a janela de dilogo que permite acesso para enviar
 //                            o e-mail  exibida.
 //            <cSubJect>  -> texto a ser exibido como "Subject" da mensagem
 //            <cText>     -> texto da mensagem. As linhas so separadas por CRLF. Pode ser ''
 //            <cSName>    -> nome de quem est enviando a mensagem (Ex.: 'Suporte Tcnico').
 //                           Pode ser ''
 //            <cSAdresse> -> e-mail de quem est enviando a mensagem. Pode ser ''
 //            <cEName>    -> nome do destinatrio. Pode ser ''
 //            <cEAdresse> -> e-mail do destinatrio. Se for '' ser aberta uma caixa de dilogo antes
 //                           de se enviar a mensagem.
 //            <cTFile>    -> encaminhamento completo do(s) arquivo(s) a ser(em) enviado(s)
 //                           separado(s) por ';'.
 //                           Pode ser ''
 //
 //
 //      Vide  http://msdn.microsoft.com/en-us/library/windows/desktop/hh707275(v=vs.85).aspx
 //      DLLFUNCTION MAPISendMailHelper(nSession,nParent,@cMessage,nFlags,nReserved) USING STDCALL FROM MAPI32.DLL
 //
 //      Retorna: '' se o e-mailfoi enviado com sucesso
 //               string contendo o erro que impediu o envio do e-mail
 /////
STATIC  cCall

LOCAL nDll
LOCAL aOriginator, cOriginator
LOCAL aRecipient, cRecipient
LOCAL aFiles, cFiles := ''
LOCAL aMessage, cMessage
LOCAL nAnzFiles := NUMTOKEN(cTFile,';',1)
LOCAL i
LOCAL cTemp
LOCAL nRet

if cCall == NIL
   nDll  := ApiLoadDll_('Mapi32.dll')
   cCall := DllPrepareCall(nDll, DLL_STDCALL, 'MAPISendMail')
//    cCall := DllPrepareCall(nDll, 'MapiSenMailHelper')
endif
cSubject  := cSubject  + CHR(0)
cText     := cText     + CHR(0)
cSName    := cSName    + CHR(0)
if Lower(Left(cSAdresse, 5)) <> 'smtp:'
   cSAdresse := ('SMTP:' + cSAdresse)
endif
cSAdresse := cSAdresse + CHR(0)
cEName    := cEName    + CHR(0)
cEAdresse := cEAdresse + CHR(0)
cTFile    := cTFile    + CHR(0)  // The file path must include the driver letter
 // Originator
aOriginator := BaInit(6)
BaStruct(aOriginator,NIL)                        // Reserved
BaStruct(aOriginator,MAPI_ORIG)                   // Type
BaStruct(aOriginator,@cSName)                     // Name
BaStruct(aOriginator,@cSAdresse)                  // Adresse
BaStruct(aOriginator,NIL)                        // ID-Size
BaStruct(aOriginator,NIL)                        // ID
cOriginator := BaAccess(aOriginator)

 // Recipient
aRecipient := BaInit(6)
BaStruct(aRecipient,NIL)                        // Reserved
BaStruct(aRecipient,MAPI_BCC)                    // Type
BaStruct(aRecipient,@cEName)                     // Name
BaStruct(aRecipient,@cEAdresse)                  // Adresse
BaStruct(aRecipient,NIL)                        // ID-Size
BaStruct(aRecipient,NIL)                        // ID
cRecipient := BaAccess(aRecipient)

IF nAnzFiles  > 0
   aFiles    := BaInit(nAnzFiles * 6)
   FOR i     := 1 TO nAnzFiles
       cTemp := ALLTRIM(TOKEN(cTFile,';',i,1)) + CHR(0)
       BaStruct(aFiles,NIL)                        // Reserved
       BaStruct(aFiles,NIL)                        // OLE-Object
       BaStruct(aFiles,-1)                          // Position
       BaStruct(aFiles,@cTemp)                      // Path
       BaStruct(aFiles,NIL)                        // File
       BaStruct(aFiles,NIL)                        // Filetype
   NEXT
   cFiles := BaAccess(aFiles)
ENDIF

aMessage := BaInit(12)
BaStruct(aMessage,NIL)                         // Reserved for future use (M.B. 0)
BaStruct(aMessage,@cSubject)                    // Message Subject
BaStruct(aMessage,@cText)                       // Message Text
BaStruct(aMessage,NIL)                         // Message Type
BaStruct(aMessage,NIL)                         // Date/Time in YYYY/MM/DD HH:MM format
BaStruct(aMessage,NIL)                         // conversation thread ID
BaStruct(aMessage,NIL)                         // unread,return receipt
BaStruct(aMessage,@cOriginator)                 // Originator
BaStruct(aMessage,1)                            // Number of Recipients
BaStruct(aMessage,@cRecipient)                  // Recipient
BaStruct(aMessage,nAnzFiles)                    // Number of Files
BaStruct(aMessage,@cFiles)                      // Files
cMessage := BaAccess(aMessage)

//nRet := DllExecuteCall(cCall, 0, nParent,@cMessage, IIF(cEAdresse == Chr(0), MAPI_DIALOG, 0),0)
nParent := 0

nRet := DllExecuteCall(cCall, 0, nParent, @cMessage, 0,0)
RETURN ApiMAPIError_(nRet)

FUNCTION ApiMAPIError_(nError)            // Returns The error text or ''
LOCAL  aErrors := {{00, ''},;                               // SUCCESS_SUCCESS. The call succeeded and the message was sent.
                   {21, 'MAPI_E_AMBIGUOUS_RECIPIENT'},;     // A recipient matched more than one of the recipient
                                                            ;// descriptor structures and MAPI_DIALOG was not set.
                                                            ;// No message was sent.
                   {11, 'MAPI_E_ATTACHMENT_NOT_FOUND'},;    // The specified attachment was not found. No message was sent.
                   {12, 'MAPI_E_ATTACHMENT_OPEN_FAILURE'},; // The specified attachment could not be opened. No message was sent.
                   {15, 'MAPI_E_BAD_RECIPTYPE'},;           // The type of a recipient was not MAPI_TO, MAPI_CC,
                                                            ;// or MAPI_BCC. No message was sent.
                   {02, 'MAPI_E_FAILURE'},;                 // One or more unspecified errors occurred. No message was sent.
                   {05, 'MAPI_E_INSUFFICIENT_MEMORY'},;     // There was insufficient memory to proceed. No message was sent.
                   {25, 'MAPI_E_INVALID_RECIPS'},;          // One or more recipients were invalid or did not resolve to any address.
                   {03, 'MAPI_E_LOGIN_FAILURE'},;           // There was no default logon, and the user failed to log on
                                                            ;//  successfully when the logon dialog box was displayed.
                                                            ;// No message was sent.
                   {18, 'MAPI_E_TEXT_TOO_LARGE'},;          // The text in the message was too large. No message was sent.
                   {09, 'MAPI_E_TOO_MANY_FILES'},;          // There were too many file attachments. No message was sent.
                   {10, 'MAPI_E_TOO_MANY_RECIPIENTS'},;     // There were too many recipients. No message was sent.
                   {27, 'MAPI_E_UNICODE_NOT_SUPPORTED'},;   // The MAPI_FORCE_UNICODE flag is specified and Unicode is not supported.
                                                            ;// Note  This value can be returned by MAPISendMailW only.
                   {14, 'MAPI_E_UNKNOWN_RECIPIENT'},;       // A recipient did not appear in the address list. No message was sent.
                   {01, 'MAPI_E_USER_ABORT'}},;             // The user canceled one of the dialog boxes. No message was sent.
       nFound, cError
nFound := AScan(aErrors, {|x| x[01] == nError})
if nFound  > 0
   cError := aErrors[nFound, 2]
else
   cError := ('MAPI - unknow error number: ' + LTrim(Str(nError)))
endif
RETURN cError

 ////////////
 //
FUNCTION ApiLoadDll_(cDll)
 //      Carrega a Dll, onde:
 //               <cDll> -> Nome da Dll a ser carregada. Se no tiver
 //                         extenso ela ser includa
 //      Retorna o handle da Dll ou 0 se ela nao pode ser carregada
 //
 /////
STATIC aDllLoaded := {}                  // Dlls carregadas: {{cDllName, nDllHandle}, ...}
LOCAL  nDllHandle

cDll := Lower(AllTrim(cDll))
if Right(cDll, 4) <> '.dll'
   cDll           += '.dll'
endif

nDllHandle    := AScan(aDllLoaded, {|x| x[01] == cDll})
if nDllHandle  > 0
   nDllHandle := aDllLoaded[nDllHandle, 02]
else
   nDllHandle := DllLoad(cDll)
   AAdd(aDllLoaded, {cDll, nDllHandle})
endif
RETURN nDllHandle

